/*  macpal flight simulator stuff brakeFix is a plugin for Microsoft Flight
    Simulator X and is released under the LGPL v3 (or later). It corrects 
    the brake output to make an autobrake working.
    Copyright 2009, 2010 Knud Krger slomo@mpfss.de

    This file is part of mpFSS.brakeFix.

    mpFSS.brakeFix is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    mpFSS.brakeFix is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with mpFSS.brakeFix.  If not, see <http://www.gnu.org/licenses/>. */
#include "stdafx.h"
#ifndef MPEXCEPTION_HPP_
#define MPEXCEPTION_HPP_

#include "errCode.hpp"
#include "filemapping.hpp"

#define MPEXCEPTION(errCode__) mpexception(errCode__, FILEID__ + __LINE__ * 10000)
#define MPEXCEPTIONMSG(errCode__, msg__) mpexception(errCode__, FILEID__ + __LINE__ * 10000, msg__)

class mpexception {
public:
    mpexception(DWORD in_errID, uint in_fileLine = 0, cpctstr msg = _T(" "));
    ~mpexception();
    DWORD           get_errCode() const;
    uint            get_fileLine() const;
    cpctstr         get_msg() const;
    cpctstr         what(bool const showMsgBox = false, cpctstr overwriteMsg = 0) const;

private:
    DWORD           errID_;
    uint            fileLine_;
    ctstr           msg_;
};

#endif
