/*  macpal flight simulator stuff brakeFix is a plugin for Microsoft Flight
    Simulator X and is released under the LGPL v3 (or later). It corrects 
    the brake output to make an autobrake working.
    Copyright 2009, 2010 Knud Krger slomo@mpfss.de

    This file is part of mpFSS.brakeFix.

    mpFSS.brakeFix is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    mpFSS.brakeFix is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with mpFSS.brakeFix.  If not, see <http://www.gnu.org/licenses/>. */
#ifndef MYFUNCTIONAL_HPP_
#define MYFUNCTIONAL_HPP_

//#include <functional>

template<typename Ret, typename Arg1, typename Arg2>
struct binary_func {
    typedef Ret     ret;
    typedef Arg1    arg1;
    typedef Arg2    arg2;
};

template<typename T, typename Ret, typename Arg1, typename Arg2>
class mem_fun2_ref_t : public binary_func<Ret, Arg1, Arg2> {
    typedef typename Ret (T::* pmf_t)(Arg1, Arg2);
    pmf_t pmf_;
public:
//    typedef T objType;
    explicit mem_fun2_ref_t(pmf_t in_pmf) : pmf_(in_pmf) {}
    inline Ret operator() (T & obj, Arg1 a1, Arg2 a2) const {
        return (obj.*pmf_)(a1, a2);
    }
};

#endif
