/*  macpal flight simulator stuff brakeFix is a plugin for Microsoft Flight
    Simulator X and is released under the LGPL v3 (or later). It corrects 
    the brake output to make an autobrake working.
    Copyright 2009, 2010 Knud Krger slomo@mpfss.de

    This file is part of mpFSS.brakeFix.

    mpFSS.brakeFix is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    mpFSS.brakeFix is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with mpFSS.brakeFix.  If not, see <http://www.gnu.org/licenses/>. */
#include "stdafx.h"
#ifndef OPTDIALOG_HPP_
#define OPTDIALOG_HPP_

#include "optData.hpp"

typedef std::vector<inputDev> inputDevVec;
#define TXTSIZE 4

INT_PTR CALLBACK optDialogCB(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

namespace {
void checkTxt(HWND const field);
} // ns anon

class optDialog {
public:
    optDialog();
    // ~optDialog();
    bool show() const;
    friend INT_PTR CALLBACK ::optDialogCB(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
private:
    explicit optDialog(optDialog const &) {}
    optDialog & operator= (optDialog const &) { return *this; }
    void enableOtherControls(bool const enable) const;
    void onComboDevChange();
    void onOk();
    void OnInit(const HWND in_hDlg);
    void setAxisPulldown(HWND const pd, int const Selection) const;

    HWND            hDlg_,
                    ComboDev_,
                    Laxis_,
                    Linverted_,
                    Ldeadzone_,
                    Raxis_,
                    Rinverted_,
                    Rdeadzone_;
    int             ComboDevSelection_;
    inputDevVec     inputDevs_;
};

#endif
