/*  macpal flight simulator stuff brakeFix is a plugin for Microsoft Flight
    Simulator X and is released under the LGPL v3 (or later). It corrects 
    the brake output to make an autobrake working.
    Copyright 2009, 2010 Knud Krger slomo@mpfss.de

    This file is part of mpFSS.brakeFix.

    mpFSS.brakeFix is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    mpFSS.brakeFix is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with mpFSS.brakeFix.  If not, see <http://www.gnu.org/licenses/>. */
#pragma once

#include "targetver.h"

#ifdef NDEBUG
#define _SECURE_SCL 0                   // iter checking off
#endif

//#define WIN32_LEAN_AND_MEAN           // Exclude rarely-used stuff from Windows headers
#define ISOLATION_AWARE_ENABLED 1       // visual crap
// Windows Header Files:
#define STRICT                          // type safety
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>

#define DIRECTINPUT_VERSION 0x0800
#include <dinput.h>
#include <dinputd.h>

// no warnings from this one
#pragma warning (push)
#pragma warning (disable : 4245)
#include <simconnect.h>
#pragma warning (pop)

#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <fstream>
#include <iostream>
using std::cout; using std::wcout; using std::endl;
#include <string>
#include <cstring>
#include <cstdio>
#include <cstdlib>
//#include <cmath>
#include <vector>
//#include <set>
#include <exception>
#include <functional>
#include <cassert>

#include <tchar.h>
#include <strsafe.h>

#include <boost/scoped_ptr.hpp>
#include <boost/scoped_array.hpp>

#ifdef UNICODE
#define tstring wstring
#else
#define tstring string
#endif

#undef HIWORD
#define HIWORD(P__) (static_cast<ULONG_PTR>(P__) >> 16)
#undef LOWORD
#define LOWORD(P__) (static_cast<ULONG_PTR>(P__) & 0xffff)

#ifdef NDEBUG
#define SOUT(t__) 
#define WSOUT(t__) 
#else
#define SOUT(t__) cout << "\n" << t__
#define WSOUT(t__) wcout << _T("\n") << t__
#endif

#define SC(type__, val__) static_cast<type__>(val__)
#define RC(type__, val__) reinterpret_cast<type__>(val__)
#ifdef DELETE
#undef DELETE
#endif
#define DELETE(p__) if (p__) { delete p__; p__ = 0; }
//#ifndef _WIN64
//#define NEW64(orgP__, useP__, T__) \
//    orgP__ = malloc( sizeof(T__) + 63 ); \
//    if ( !orgP__ ) { throw std::bad_alloc(); } \
//    useP__ = new( RC(T__*, ( (RC(LONG_PTR, orgP__) + 63) & 0xffffffc0) )) T__();
//#else
//#error sorry the NEW64 macro is not 64bit safe..\
// but this doesnt matter since fsx is a 32bit app which cannot load a 64bit dll AFAIK
//#endif
//#define DELETE64(orgP__, useP__, T__) \
//    if ( useP__ ) { useP__->~T__(); useP__ = 0; } \
//    if ( orgP__ ) { free(orgP__); orgP__ = 0; }

#include "bits.hpp"

enum {
    PEDALMIN = -32768,
    PEDALMAX =  32768,
    BRAKEMIN = -16384,
    BRAKEMAX =  16383,
    PEDALMAXCOMBINED = 65536
};

typedef unsigned char       uchar;
typedef char const *        ccstr;
typedef char const * const  cpccstr;
typedef TCHAR const *       ctstr;
typedef TCHAR const * const cpctstr;
typedef unsigned int        uint;
typedef unsigned short      ushort;
typedef std::pointer_to_binary_function<uint, uint, void> binfunctor;
