/*  macpal flight simulator stuff brakeFix is a plugin for Microsoft Flight
    Simulator X and is released under the LGPL v3 (or later). It corrects 
    the brake output to make an autobrake working.
    Copyright 2009, 2010 Knud Krüger slomo@mpfss.de

    This file is part of mpFSS.brakeFix.

    mpFSS.brakeFix is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    mpFSS.brakeFix is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with mpFSS.brakeFix.  If not, see <http://www.gnu.org/licenses/>. */
#include "stdafx.h"

#include "dispatchProc.hpp"
#include "MapDataSubEvents.hpp"
#include "optData.hpp"
#include "addMenus.hpp"
#include "Aligned2.hpp"
#include "MsgBox.hpp"

class optDialog;
HANDLE          g_scHandle =      0;
HWND            g_winHWND =       0;
HINSTANCE       g_hInst =         0;
optDialog *     g_optsDialog =    0;
//void *          g_optionsOrg =    0;
//optData *       g_options =       0;
Aligned2<optData> g_options;
bool            g_brakesOn =      false;
bool            g_enabled =       false;
char            padding[2] =      {0};
MsgBox<binfunctor> *  g_msgbox =  0;
ctstr           g_msg_mpFssErr =  _T("mpFSS.brakeFix error");
ctstr           g_msg_mpFss =     _T("mpFSS.brakeFix");
ctstr           g_aboutStr =      _T("mpFSS.brakeFix version 1.00.001\n")
                                  _T("Copyright 2009, 2010 Knud Kr\x00FCger http://mpfss.de\n\n")
                                  _T("This software comes with ABSOLUTELY NO WARRANTY;\n")
                                  _T("This is free software, and you are welcome to\n")
                                  _T("redistribute it under certain conditions; for details\n")
                                  _T("see COPYING.LESSER.txt and COPYING.txt");
#include "strings.hpp"
                                      

#define DLLEXPORT extern "C" __declspec(dllexport)

DLLEXPORT void DLLStart(void) {
    SOUT("this is DLLStart");
    if ( SimConnect_Open( &g_scHandle,
                          "de.mpFSS.brakeFix",
                          g_winHWND,                // hWnd Handle to a Windows object.
                          0,                        // UserEventWin32
                          0,                        // A Windows Event handle
                          0)                        // config index
        != S_OK ) {
        return;
    }

    try {
//        NEW64(g_optionsOrg, g_options, optData)
        g_options.allocAndConstruct();
    } catch (std::exception &) {
        MessageBox(0, errMsg::get(0), 
                   g_msg_mpFssErr, MB_ICONERROR | MB_OK | MB_TASKMODAL);
        return;
    }

    g_options->readOptFile();

    if ( SimConnect_CallDispatch(g_scHandle, &DispatchAlot, 0) != S_OK ) {
        return;
    }
    addMenus();
    mapDataSubEvents();
    
    // visual style crap
    INITCOMMONCONTROLSEX ccex;
    ccex.dwSize = sizeof(INITCOMMONCONTROLSEX);
    ccex.dwICC = ICC_NATIVEFNTCTL_CLASS | ICC_STANDARD_CLASSES | 
                 ICC_USEREX_CLASSES | ICC_UPDOWN_CLASS;
    BOOL ret = InitCommonControlsEx( &ccex );
#ifndef NDEBUG
    SOUT( "InitCommonControls = " << ret << "\n");
#else
    (ret);
#endif

    SOUT("this is DLLStart done");
}

DLLEXPORT void DLLStop(void) {
    if ( g_scHandle ) {
        SimConnect_Close(g_scHandle);
    }
//    DELETE64(g_optionsOrg, g_options, optData)
//#ifndef NDEBUG
//    SOUT("dumping leaks..\n");
//    _CrtDumpMemoryLeaks();
//    SOUT("finished dumping leaks");
//#endif
    return;
}

#ifdef NDEBUG
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID /* lpvReserved */) {
#else
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved) {
#endif
    SOUT("this is DllMain");
    switch (fdwReason) {
    case DLL_PROCESS_ATTACH:
        SOUT("DLL_PROCESS_ATTACH");
        g_hInst = hinstDLL;
        g_winHWND = FindWindow(0, _T("Microsoft Flight Simulator X"));
        if ( !g_winHWND ) {
            MessageBox(0, errMsg::get(1), g_msg_mpFssErr, MB_OK | MB_ICONERROR);
        }
        SOUT("g_hInst = " << g_hInst << "\n");
        SOUT("g_winHWND = " << g_winHWND << "\n");
        break;
#ifndef NDEBUG
    case DLL_THREAD_ATTACH:
        SOUT("DLL_THREAD_ATTACH");
        break;
    case DLL_THREAD_DETACH:
        SOUT("DLL_THREAD_DETACH");
        break;
    case DLL_PROCESS_DETACH:
        SOUT("DLL_PROCESS_DETACH");
        break;
    default:
        SOUT("hm did not understand the fdwReason");
        break;
#endif
    }
    SOUT("DllMain hinstDLL=" << hinstDLL << " g_winHWND = " << g_winHWND 
         << " fdwReason=" << fdwReason << " lpvReserved=" << lpvReserved << std::endl);
    return TRUE;
}
