/*  macpal flight simulator stuff brakeFix is a plugin for Microsoft Flight
    Simulator X and is released under the LGPL v3 (or later). It corrects 
    the brake output to make an autobrake working.
    Copyright 2009, 2010 Knud Krger slomo@mpfss.de

    This file is part of mpFSS.brakeFix.

    mpFSS.brakeFix is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    mpFSS.brakeFix is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with mpFSS.brakeFix.  If not, see <http://www.gnu.org/licenses/>. */
#include "stdafx.h"

#include "MapDataSubEvents.hpp"
#include "events.hpp"

#include "globals.hpp"

void mapDataSubEvents() {
    SimConnect_MapClientEventToSimEvent(g_scHandle, ev_brake, "BRAKES");
    SimConnect_MapClientEventToSimEvent(g_scHandle, ev_pedalL, "AXIS_LEFT_BRAKE_SET");
    SimConnect_MapClientEventToSimEvent(g_scHandle, ev_pedalR, "AXIS_RIGHT_BRAKE_SET");
    SimConnect_MapClientEventToSimEvent(g_scHandle, ev_throttle, "THROTTLE_CUT");
    SimConnect_AddToDataDefinition(g_scHandle, in_throttle, 
                                   "GENERAL ENG THROTTLE LEVER POSITION:1",
                                   "percent", SIMCONNECT_DATATYPE_FLOAT32, 0.0f);
    SimConnect_MapClientEventToSimEvent(g_scHandle, in_pedalL);
    SimConnect_MapClientEventToSimEvent(g_scHandle, in_pedalR);
    SimConnect_MapClientEventToSimEvent(g_scHandle, ev_options);
    SimConnect_MapClientEventToSimEvent(g_scHandle, ev_msgbox);
    SimConnect_AddClientEventToNotificationGroup(g_scHandle, ngidNormal, ev_options, false);
    SimConnect_AddClientEventToNotificationGroup(g_scHandle, ngidNormal, ev_msgbox, false);
    SimConnect_SetNotificationGroupPriority(g_scHandle, ngidNormal, 
                                            SIMCONNECT_GROUP_PRIORITY_DEFAULT);
#ifndef NDEBUG
    SimConnect_AddToDataDefinition(g_scHandle, data_brakes, "BRAKE LEFT POSITION",
        "percent", SIMCONNECT_DATATYPE_FLOAT32, 0.0f);
    SimConnect_AddToDataDefinition(g_scHandle, data_brakes, "BRAKE RIGHT POSITION",
        "percent", SIMCONNECT_DATATYPE_FLOAT32, 0.0f);
    SimConnect_RequestDataOnSimObject(g_scHandle, data_brakes, data_brakes,
        SIMCONNECT_OBJECT_ID_USER, SIMCONNECT_PERIOD_SIM_FRAME, 0, 0, 8, 0);
#endif
}
