/*  macpal flight simulator stuff brakeFix is a plugin for Microsoft Flight
    Simulator X and is released under the LGPL v3 (or later). It corrects 
    the brake output to make an autobrake working.
    Copyright 2009, 2010 Knud Krger slomo@mpfss.de

    This file is part of mpFSS.brakeFix.

    mpFSS.brakeFix is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    mpFSS.brakeFix is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with mpFSS.brakeFix.  If not, see <http://www.gnu.org/licenses/>. */
#include "stdafx.h"
#include "mpexception.hpp"
#include "MsgBox.hpp"

mpexception::mpexception(DWORD in_errID, uint in_fileLine, cpctstr msg)
        : errID_(in_errID), fileLine_(in_fileLine), msg_(msg) {}

mpexception::~mpexception() {}

DWORD mpexception::get_errCode() const {
    return errID_;
}

uint mpexception::get_fileLine() const {
    return fileLine_;
}

cpctstr mpexception::get_msg() const {
    return msg_;
}

cpctstr mpexception::what(bool const showMsgBox, cpctstr overwriteMsg) const {
    assert(msg_);
    enum { strSize = 256 };
    static TCHAR r[strSize];
    memset(r, 0, strSize * sizeof(TCHAR) );
    StringCbPrintf(r, strSize * sizeof(TCHAR) - sizeof(TCHAR), _T("eID: %d fID: %d\n%s"),
               errID_, fileLine_, overwriteMsg ? overwriteMsg : msg_);
    if ( showMsgBox ) {
        MsgBox<>::singleton().set(r);
    }
    return r;
}
